import type { VNode, ComponentChild } from 'preact';
interface FiberContainer extends HTMLElement {
    __containerInfo: any;
    __hostConfig: any;
}
export interface Fiber extends VNode {
    __c: {
        __P: FiberContainer;
    };
    __: Fiber;
    __type?: string;
    __container: FiberContainer;
    stateNode?: any;
    props: any;
    memoizedProps: any;
    __e: HTMLElement & {
        __vnode?: Fiber;
        __hostConfig: any;
        __containerInfo: any;
        [key: string]: unknown;
    };
}
type Type = string;
type Props = Record<string, unknown>;
type Container = unknown;
type Instance = unknown;
type TextInstance = unknown;
type PublicInstance = unknown;
type HostContext = unknown;
type UpdatePayload = unknown;
type OpaqueHandle = Fiber;
type OpaqueRoot = FiberContainer;
export interface HostConfig {
    createInstance(type: Type, props: Props, rootContainer: Container, hostContext: HostContext, internalHandle: OpaqueHandle): Instance;
    finalizeInitialChildren(instance: Instance, type: Type, props: Props, rootContainer: Container, hostContext: HostContext): boolean;
    prepareUpdate(instance: Instance, type: Type, oldProps: Props, newProps: Props, rootContainer: Container, hostContext: HostContext): UpdatePayload | null;
    getPublicInstance(instance: Instance | TextInstance): PublicInstance;
    appendChild?(parent: Instance, child: Instance | TextInstance): void;
    appendChildToContainer?(container: Container, child: Instance | TextInstance): void;
    insertBefore?(parent: Instance, child: Instance | TextInstance, beforeChild: Instance | TextInstance): void;
    insertInContainerBefore?(container: Container, child: Instance | TextInstance, beforeChild: Instance | TextInstance): void;
    removeChild?(parent: Instance, child: Instance | TextInstance): void;
    removeChildFromContainer?(container: Container, child: Instance | TextInstance): void;
    commitMount?(instance: Instance, type: Type, props: Props, internalHandle: OpaqueHandle): void;
    commitUpdate?(instance: Instance, updatePayload: UpdatePayload, type: Type, prevProps: Props, nextProps: Props, internalHandle: OpaqueHandle): void;
    [name: string]: unknown;
}
export interface Reconciler {
    createContainer(containerInfo: any): OpaqueRoot;
    createPortal(children: ComponentChild, containerInfo: any, implementation: any, key?: string | null): ComponentChild;
    updateContainer(element: ComponentChild, container: OpaqueRoot): void;
    injectIntoDevTools(devToolsConfig: any): any;
}
export {};
